
/*!
@since 2003/9/29
*/


#ifndef _dkutilCriticalSection__h_
#define _dkutilCriticalSection__h_

#include "dKingyoMacro.h"
#include "dkutilDefinedC.h"

namespace dkutil{

#ifdef _MT //Multi ThreadB

#	ifdef USE_DKINGYO_YANESDK3RD	//yaneSDK3rdĝȂ

class DKCriticalSection : public CCriticalSection{
public:
	DKCriticalSection() : CCriticalSection(){}
	virtual ~DKCriticalSection(){}
};

#	else ///yaneSDK3rdgȂȂ祥

///yaneSDK3rdQlɂ܂B...ARsyɋ߂॥߂Ȃm(jj)m
class DKCriticalSection{
public:
	DKCriticalSection(){
		::InitializeCriticalSection(&m_csCriticalSection);
		m_dwLockedThread = (DWORD)-1;
		mLockCount	= 0;
		//ODS("Init CriticalSection");
	}

	virtual ~DKCriticalSection(){
		::DeleteCriticalSection(&m_csCriticalSection);
		if (mLockCount!=0) {
#	ifdef USE_DKINGYO_THROW
			throw std::logic_error("DKCriticalSectionEnter񐔂LeaveȂ܂܏IĂ");
#	else
			MB("DKCriticalSectionEnter񐔂LeaveȂ܂܏IĂ");
#	endif
		}
		//ODS("End CriticalSection");
	}

	///	CriticalSectionɓ
	void Enter(){
		::EnterCriticalSection(&m_csCriticalSection);
		
		m_dwLockedThread = ::GetCurrentThreadId();
		//	قȂXbh炱ɓĂ邱Ƃ͂łȂ
		//	(CriticalSection̒`)
		mLockCount++;

	}

	///CriticalSection甲
	void Leave(){

		if (mLockCount==0){
#	ifdef USE_DKINGYO_THROW
			throw  std::logic_error("DKCriticalSectionEnterĂȂ̂LeaveĂ");
#	else
			MB("DKCriticalSectionEnterĂȂ̂LeaveĂ");
#	endif
		}

		if (--mLockCount==0) {
			m_dwLockedThread = (DWORD)-1;
		}
		//	LeaveɑXbhEnter\
		::LeaveCriticalSection(&m_csCriticalSection);
	}

	bool IsLockedByThisThread() const{
		DWORD dw = ::GetCurrentThreadId();
		return (m_dwLockedThread == dw);
	}
	
protected:
	CRITICAL_SECTION m_csCriticalSection;
	DWORD				m_dwLockedThread;	//	LockĂThreadId(0:Lock)
	int					mLockCount;		//	LockĂ
			//	(XbhȂΕLockł̂)
};

#	endif //end of USE_DKINGYO_YANESDK3RD	

#else //Single Thread祥

class DKCriticalSection{
public:
	DKCriticalSection(){

	}

	virtual ~DKCriticalSection(){

	}
	///	CriticalSectionɓ
	void Enter(){
	}
	///CriticalSection甲
	void Leave(){

	}

	bool IsLockedByThisThread() const{
		return false;
	}
protected:
};

#endif//end of _MT


namespace private_{

extern DKCriticalSection &GetCriticalSection();

}

}//end of dkutil namespace
















#endif //end of include once 